package WWW::GameFAQs::Archive::Internal;

=head1 COPYRIGHT

Copyright 2010 Kodi Arfer.

This program is free software. You may copy or redistribute it under the same terms as Perl itself.

=cut

use HTML::Entities;
use CGI::Cookie;
use DateTime::TimeZone;

use parent 'Exporter';
@WWW::GameFAQs::Archive::Internal::EXPORT_OK =
    qw(htmlsafe div time_zone read_time_zone ceiling);

sub ceiling
   {my $x = shift;
    $x == int $x ? $x : int($x) + 1;}

sub htmlsafe
   {encode_entities $_[0], q(<>&"')}

sub div
   {sprintf '<div class="%s">%s</div>',
        $_[0],
        join '', @_[1..$#_]}

sub time_zone ()
   {my %h = fetch CGI::Cookie;
    $h{wgfa_time_zone} or return 'UTC';
    read_time_zone($h{wgfa_time_zone}->value) or 'UTC';}

sub read_time_zone
# Primarily important for its untainting function.
   {my $s = shift;
    $s =~ m!\A([0-9a-zA-Z_/]+)\z! or return undef;
    my $t = $1;
    DateTime::TimeZone->is_valid_name($t) and $t ne 'floating'
      ? DateTime::TimeZone->new(name => $t)->name
          # This canonicalizes $t; e.g., "GMT" will become "UTC'.
      : undef;}

1;
